﻿using SushiBarContracts.BindingModels;
using SushiBarContracts.ViewModels;

namespace SushiBarContracts.BusinessLogicsContracts
{
    public interface IReportLogic
    {
        /// <summary>
        /// Получение списка индгредиентов с указанием, в каких суши используются
        /// </summary>
        /// <returns></returns>
        List<ReportSushiIngredientViewModel> GetSushiIngredient();

        /// <summary>
        /// Получение списка заказов за определенный период
        /// </summary>
        /// <param name="model"></param>
        /// <returns></returns>
        List<ReportOrdersViewModel> GetOrders(ReportBindingModel model);

        /// <summary>
        /// Сохранение индгредиентов в файл-Word
        /// </summary>
        /// <param name="model"></param>
        void SaveListSushiToWordFile(ReportBindingModel model);

        /// <summary>
        /// Сохранение индгредиентов с указаеним суши в файл-Excel
        /// </summary>
        /// <param name="model"></param>
        void SaveSushiIngredientToExcelFile(ReportBindingModel model);

        /// <summary>
        /// Сохранение заказов в файл-Pdf
        /// </summary>
        /// <param name="model"></param>
        void SaveOrdersToPdfFile(ReportBindingModel model);
    }
}
